<template>
  <v-container class="pa-0">
    <v-row>
      <v-col cols="12">
        <v-card flat>
          <v-card-title class="text-md-h5 text-sm-h6">Audit Framework Assignments</v-card-title>
          <v-card-subtitle>View Compliance Framework Usage within a Group</v-card-subtitle>
        </v-card>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-card flat>
            <v-card-title>Select a Group to Audit<v-spacer></v-spacer><v-switch dense hide-details inset class="ma-0 pa-0" label="Search Top Level Only" v-model="topLevelOnly"></v-switch></v-card-title>
            <v-card-text>
              <GroupSelector :topLevelOnly="topLevelOnly" :selectedGroup.sync="group"></GroupSelector>
            </v-card-text>
        </v-card>
      </v-col>
    </v-row>
    <v-row v-if="groupSelected">
      <v-col cols="12">
        <v-card flat v-if="complianceLoading">
          <v-card-title>
            <span class="flex-grow-1" style="align-items: top">
              <v-skeleton-loader type="card-heading"></v-skeleton-loader>
            </span>
            <v-skeleton-loader class="text-align-top pr-4" type="button"></v-skeleton-loader>
          </v-card-title>
          <v-card-subtitle>
          </v-card-subtitle>
          <v-card-text>
            <v-skeleton-loader type="list-item@3"></v-skeleton-loader>
          </v-card-text>
        </v-card>
        <v-card v-else flat>
          <v-card-title>
            Group: {{ group.name }}&nbsp;
            <v-btn x-small icon :href="groupUri" target="_blank"><v-icon color="primary">mdi-open-in-new</v-icon></v-btn>
            <v-spacer></v-spacer>
            <v-btn depressed small color="primary lighten-1" @click="loadGroupAudit" :loading="auditLoading">
              <v-icon>{{ auditTableData.length > 0 ? 'mdi-refresh' : 'mdi-play' }}</v-icon>
              {{ auditTableData.length > 0 ? 'Refresh Audit' : 'Run Audit' }}
            </v-btn>
          </v-card-title>
          <v-card-subtitle>Full Name: {{ group.full_name }}<br>Path: {{ group.full_path }}</v-card-subtitle>

          <v-subheader class="text-subtitle-1 black--text">Compliance Frameworks in this Group</v-subheader>
          <v-card-subtitle class="pt-0" v-if="group.id != topLevelGroup.id">
            From Top-Level Group: {{ topLevelGroup.name }}
            <v-btn x-small icon :href="topLevelGroup.web_url" target="_blank"><v-icon color="primary">mdi-open-in-new</v-icon></v-btn>
          </v-card-subtitle>

          <v-simple-table dense fixed-header :height="complianceFrameworks[topLevelGroup.id].length > 4 ? '200px' : undefined" class="pb-6">
            <template v-slot:default>
              <thead>
                <tr>
                  <th class="text-left">Name</th>
                  <th class="text-left">Description</th>
                  <th class="text-left">Pipeline Path</th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="(item, i) in complianceFrameworks[topLevelGroup.id]" :key="i">
                  <td><v-icon small :color="item.color">mdi-circle</v-icon> {{ item.name }}</td>
                  <td>{{ item.description }}</td>
                  <td class="text-caption">{{ item.pipelineConfigurationFullPath }}</td>
                </tr>
              </tbody>
            </template>
          </v-simple-table>
        </v-card>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-card flat v-if="auditLoading">
          <v-card-title class="pa-10">
            <v-spacer></v-spacer><Tanuki :loading="true" size="150"></Tanuki><v-spacer></v-spacer>
          </v-card-title>
        </v-card>
        <v-card v-if="!auditLoading && auditTableData.length > 0" flat>
          <v-card-title>
            Project Compliance Audit
            <v-spacer></v-spacer>
            <v-menu offset-y close-on-click>
              <template v-slot:activator="{ on, attrs }">
                <v-btn small depressed color="primary lighten-1" v-bind="attrs" v-on="on">
                  <v-icon>mdi-download</v-icon> Download
                </v-btn>
              </template>
              <v-list dense>
                <v-list-item @click="downloadFullAudit">
                  <v-list-item-title>Full Audit</v-list-item-title>
                </v-list-item>
                <v-list-item @click="downloadFilteredAudit">
                  <v-list-item-title>Filtered Only</v-list-item-title>
                </v-list-item>
              </v-list>
            </v-menu>
          </v-card-title>
          <AuditChart :data="auditTableData" :frameworks="frameworksByName"></AuditChart>
          <v-card-title class="text-subtitle-1">
            Project List
            <v-spacer></v-spacer>
            <v-container>
              <v-row>
                <v-col cols="6">
                  <v-select
                    dense
                    small-chips
                    clearable
                    hide-details
                    multiple
                    single-line
                    v-model="auditTableFilterSelections"
                    :items="frameworkFilterItems"
                    item-text="name"
                    item-value="value"
                    label="Filter on frameworks"
                    :menu-props="{ bottom: true, offsetY: true }">
                    <template v-slot:prepend>
                      <v-icon small>mdi-filter-variant</v-icon>
                    </template>
                    <template v-slot:selection="{ attrs, item, select, selected}">
                      <v-chip label small :input-value="selected" close @click="select" @click:close="removeFrameworkSelectionFilter(item)"><v-icon small :color="item.color">mdi-circle</v-icon>{{ item.name }}</v-chip>
                    </template>
                  <template v-slot:item="{ item, attrs, on }">
                    <v-list-item v-on="on" v-bind="attrs" #default="{ active }">
                      <v-list-item-action>
                        <v-checkbox :ripple="false" :input-value="active"></v-checkbox>
                      </v-list-item-action>
                      <v-list-item-content>
                        <v-list-item-title>
                          <v-icon v-if="item.name === NO_FRAMEWORK_NAME" small :color="item.color">mdi-circle-outline</v-icon>
                          <v-icon v-else small :color="item.color">mdi-circle</v-icon>
                          <span class="text-body-2 pl-1">{{ item.name }}</span>
                        </v-list-item-title>
                      </v-list-item-content>
                    </v-list-item>
                  </template>
                  </v-select>
                </v-col>
                <v-col cols="6">
                  <v-text-field dense v-model="projectSearchFilter" label="Filter on project name or path" single-line hide-details clearable>
                    <template v-slot:prepend>
                      <v-icon small>mdi-magnify</v-icon>
                    </template>
                  </v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-card-title>
          <v-data-table
          id="auditTable"
          :items="filteredAuditTableData"
          :headers="auditTableDataHeaders"
          :footer-props="{'items-per-page-options': [20, 50, 100, -1]}"
          dense
          :items-per-page="20">
            <template v-slot:item.complianceFramework="{ item }">
              <div v-if="item.hasComplianceFramework"><v-icon small :color="item.complianceFramework.color">mdi-circle</v-icon> {{ item.complianceFramework.name }}</div>
              <div v-else><v-icon small color="grey">mdi-circle-outline</v-icon> No Framework</div>
            </template>
            <template v-slot:item.webUrl="{ item }">
              <td><v-btn x-small icon :href="item.webUrl" target="_blank"><v-icon color="primary">mdi-open-in-new</v-icon></v-btn></td>
            </template>
          </v-data-table>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<style scoped>
  #auditTable {
    min-height: 600px;
  }
</style>

<script lang="ts">
import { Component, Mixins, Watch } from 'vue-property-decorator'
import GroupSelector from '../components/GroupSelector.vue'
import * as Queries from '../lib/graphql_queries'
import ApiAccess from '@/mixins/apiAccess'
import * as Excel from 'xlsx'
import Tanuki from '../components/Tanuki.vue'
import AuditChart from '../components/AuditChart.vue'

  @Component({
    components: { GroupSelector, Tanuki, AuditChart }
  })
export default class Audit extends Mixins(ApiAccess) {
  NO_FRAMEWORK_NAME = 'No Framework'
  projectSearchFilter = ''
  reload = true
  auditLoading = false
  complianceLoading = false
  topLevelOnly = false
  auditTableFilterSelections: string[] = []
  group: any = null
  topLevelGroup: any = null
  complianceFrameworks: Record<string, any> = {}
  auditData: any = {}

  @Watch('group')
  async groupChanged (): Promise<void> {
    if (this.group) {
      this.topLevelGroup = await this.findTopLevelGroup(this.group)
    }
  }

  get groupSelected (): boolean {
    return this.group && this.topLevelGroup
      ? Object.keys(this.group).length > 0 && Object.keys(this.topLevelGroup).length > 0
      : false
  }

  get frameworksByName (): any {
    const frameworks: any = {}
    this.complianceFrameworks[this.topLevelGroup.id].map((entry: any) => {
      frameworks[entry.name] = entry
    })

    return frameworks
  }

  get frameworkFilterItems (): any[] {
    const noFramework = {
      name: 'No Framework',
      color: 'grey'
    }
    return [noFramework, ...this.complianceFrameworks[this.topLevelGroup.id].map((entry: any) => {
      return { name: entry.name, color: entry.color }
    })
    ]
  }

  removeFrameworkSelectionFilter (item: any): any {
    this.auditTableFilterSelections.splice(this.auditTableFilterSelections.indexOf(item), 1)
  }

  @Watch('topLevelGroup')
  onGroupChange (): void {
    const scope = this.topLevelGroup
    if (scope && scope.full_path) {
      this.complianceLoading = true
      this.$apollo.query({
        query: Queries.GET_GROUP_COMPLIANCE_FRAMEWORKS,
        variables: {
          fullPath: scope.full_path ?? null
        }
      }).then((result: any) => {
        this.complianceFrameworks[this.topLevelGroup.id] = result.data.group.complianceFrameworks.nodes
      }).finally(() => {
        this.complianceLoading = false
      })
    }
  }

  auditTableDataHeaders = [
    {
      text: 'Project Name',
      value: 'name',
      sortable: true,
      filterable: true
    },
    {
      text: 'Path',
      value: 'path',
      sortable: true,
      filterable: true
    },
    {
      text: 'Compliance Framework',
      value: 'complianceFramework',
      sortable: true
    },
    {
      text: '',
      value: 'webUrl',
      sortable: false,
      filterable: false
    }
  ]

  get groupUri (): string {
    return this.group.web_url
  }

  get auditTableData (): any[] {
    if (this.auditLoading) {
      return []
    } else {
      return this.auditData[this.group?.id] ?? []
    }
  }

  get filteredAuditTableData (): any {
    if (this.projectSearchFilter == null || this.projectSearchFilter === '') {
      return this.auditTableFilteredByFramework
    } else {
      return this.auditTableFilteredByFramework.filter((entry: any) => {
        const searchTerm = this.projectSearchFilter.toLowerCase()
        return this.auditTableDataHeaders.filter((property: any) => property.filterable).some((property:any) => {
          const value = entry[property.value].toLowerCase()
          return value.indexOf(searchTerm) !== -1
        })
      })
    }
  }

  get auditTableFilteredByFramework (): any {
    if (this.auditTableFilterSelections.length === 0) {
      return this.auditTableData
    } else {
      return this.auditTableData.filter((entry: any) => {
        const matcher = entry.hasComplianceFramework ? entry.complianceFramework.name : this.NO_FRAMEWORK_NAME
        return this.auditTableFilterSelections.includes(matcher)
      })
    }
  }

  async loadGroupAudit (): Promise<void> {
    this.auditLoading = true
    const projects = await this.getRestAPI().Groups.projects(this.group.id, { include_subgroups: true, with_shared: false })
    const data = projects.map((entry: any) => {
      const project: any = {
        id: entry.id,
        name: entry.name,
        path: entry.path_with_namespace,
        description: entry.description,
        webUrl: entry.web_url,
        hasComplianceFramework: false
      }
      const complianceFrameworks = entry.compliance_frameworks
      if (complianceFrameworks) {
        const framework = this.frameworksByName[complianceFrameworks[0]]
        if (framework) {
          project.complianceFramework = {
            name: framework.name,
            color: framework.color,
            pipeline: framework.pipelineConfigurationFullPath
          }
          project.hasComplianceFramework = true
        }
      }

      return project
    })

    this.auditData[this.group.id] = data
    this.auditLoading = false
  }

  downloadFullAudit () : void {
    this.downloadAuditReport(this.auditTableData)
  }

  downloadFilteredAudit () : void {
    this.downloadAuditReport(this.filteredAuditTableData)
  }

  downloadAuditReport (data: any): void {
    const workbook = Excel.utils.book_new()

    Excel.utils.book_append_sheet(workbook, this.buildFrameworkSheet(), 'Compliance Frameworks')
    Excel.utils.book_append_sheet(workbook, this.buildProjectSheet(data), 'Projects')

    var fileName = `${this.group.name}-audit.xlsx`

    // eslint-disable-next-line security/detect-non-literal-fs-filename
    Excel.writeFile(workbook, fileName)
  }

  buildFrameworkSheet (): any {
    const header = [['ID', 'Name', 'Description', 'Color', 'Pipeline Template']]
    const data: any[] = []

    this.complianceFrameworks[this.topLevelGroup.id].forEach((framework: any) => {
      const sheetEntry: any = {
        id: framework.id,
        name: framework.name,
        description: framework.description,
        color: framework.color,
        pipeline: framework.pipelineConfigurationFullPath
      }

      data.push(sheetEntry)
    })

    const sheet = Excel.utils.json_to_sheet([])
    Excel.utils.sheet_add_aoa(sheet, header)
    Excel.utils.sheet_add_json(sheet, data, { origin: 'A2', skipHeader: true })
    sheet['!cols'] = [
      { width: 45 },
      { width: 20 },
      { width: 40 },
      { width: 10 },
      { width: 80 }
    ]

    return sheet
  }

  buildProjectSheet (data: any): any {
    const header = [['ID', 'Name', 'Path', 'Compliance Framework', 'URL']]
    const output: any[] = []

    data.forEach((project: any) => {
      const sheetEntry: any = {
        id: project.id,
        name: project.name,
        path: project.path,
        complianceFrameworkName: project.hasComplianceFramework ? project.complianceFramework.name : '',
        url: project.webUrl
      }

      output.push(sheetEntry)
    })

    const sheet = Excel.utils.json_to_sheet([])
    Excel.utils.sheet_add_aoa(sheet, header)
    Excel.utils.sheet_add_json(sheet, output, { origin: 'A2', skipHeader: true })
    sheet['!cols'] = [
      { width: 10 },
      { width: 30 },
      { width: 40 },
      { width: 30 },
      { width: 80 }
    ]

    return sheet
  }
}

</script>
